# Learning with Examples: GraphQL and Koios

## How to use this documentation:

1. Try to read of the components below.
2. Try to get each these examples working in your local development environment. Then try to change them.
3. Don't be afraid to "break things" - you have your own copy of the original repository, and it's no big deal if you mess it up. You can always delete your local changes and start over!
4. Take notes what you know and don't know. Take notes on what you want to know and what inspires you.

<br />
---

## GraphQL Query + CheckAddressHasContributorToken Component

Based on [CheckAddressHasContributorToken](https://gitlab.com/gimbalabs/ppbl-2023/ppbl-front-end-template-2023/-/blob/main/src/components/course-modules/102/cardano/CheckAddressHasContributorToken.tsx), as first seen in [MasteryAssignment 102.1](/modules/102/assignment1021)

```tsx
// Import Statements:
import { contributorPolicyID } from 'gpte-config';
import { gql, useLazyQuery } from '@apollo/client';
import {
	Box,
	Heading,
	FormControl,
	FormLabel,
	Input,
	Button,
	Text,
	Center,
	Spinner,
} from '@chakra-ui/react';
import { useFormik } from 'formik';
import { useState } from 'react';

// GraphQL Query Definition:
const UTXO_AT_ADDRESS_WITH_CONTRIBUTOR_TOKEN = gql`
	query GetUTxOAtAddress($address: String!, $tokenPolicyId: Hash28Hex!) {
		utxos(
			where: {
				_and: [
					{ address: { _eq: $address } }
					{ tokens: { asset: { policyId: { _eq: $tokenPolicyId } } } }
				]
			}
		) {
			txHash
		}
	}
`;

// The <QueryComponent /> that is imported to /ppbl-2023-front-end-starter/src/pages/index.tsx
export const QueryComponent = () => {
	// useState hook to store address from user input
	const [queryAddress, setQueryAddress] = useState<string | undefined>(
		undefined
	);

	// useFormik hook from formik library
	// Makes it easier to handle forms in React
	const formik = useFormik({
		initialValues: {
			cardanoAddress: '',
		},
		onSubmit: (values) => {
			setQueryAddress(values.cardanoAddress);
		},
	});

	// useLazyQuery hook from @apollo/client library
	// Handles fetching of GraphQL data
	// The name getUTxO can be anything we choose. This is a good name because it descibes what we are doing.
	const [getUTxO, { loading, error, data }] = useLazyQuery(
		UTXO_AT_ADDRESS_WITH_CONTRIBUTOR_TOKEN
	);

	// When a button is clicked, set the queryAddress and run the getUTxO query defined above
	const handleClick = () => {
		setQueryAddress(formik.values.cardanoAddress);
		getUTxO({
			variables: {
				address: formik.values.cardanoAddress,
				tokenPolicyId: contributorPolicyID,
			},
		});
	};

	// Boilerplate to handle useLazyQuery loading state.
	if (loading)
		return (
			<Center flexDirection='column'>
				<Heading>Loading</Heading>
				<Spinner />
			</Center>
		);

	// Boilerplate to handle useLazyQuery error state.
	if (error)
		return (
			<Center>
				<Heading>Error</Heading>
				<pre>{JSON.stringify(error)}</pre>
			</Center>
		);

	// If the query is not loading or in error state, this will be rendered on the page:
	return (
		<Box bg='theme.light' color='theme.dark' p='3'>
			<Heading size='md' py='3'>
				Check Address For PPBL2023 Token
			</Heading>
			<Text py='3'>
				Use this form to check if any address currently holds a PPBL 2023
				Contributor Token. Try your address and any others:
			</Text>
			<FormControl p='5' bg='theme.dark' color='theme.light'>
				<FormLabel>Enter a Cardano Preprod Address:</FormLabel>
				<Input
					mt='3'
					id='cardanoAddress'
					name='cardanoAddress'
					onChange={formik.handleChange}
					value={formik.values.cardanoAddress}
					placeholder='Preprod Address'
				/>
				<Button onClick={handleClick} size='sm' mt='3'>
					Check Address
				</Button>
				{queryAddress &&
					data &&
					(data.utxos.length > 0 ? (
						<Box bg='green.400' color='theme.dark' mt='5' p='3' fontSize='sm'>
							{queryAddress} currently holds a PPBL2023 Contributor Token.
						</Box>
					) : (
						<Box bg='red.400' color='theme.dark' mt='5' p='3' fontSize='sm'>
							{queryAddress} does not hold a PPBL2023 Contributor Token.
						</Box>
					))}
			</FormControl>
		</Box>
	);
};
```

<br />
---

## GraphQL Query + CheckTxFromAddressWithPolicyID Component

Based on [CheckTxFromAddressWithPolicyID](https://gitlab.com/gimbalabs/ppbl-2023/ppbl-front-end-template-2023/-/blob/main/src/components/course-modules/102/cardano/CheckTxFromAddressWithPolicyID.tsx), as first seen in [MasteryAssignment 102.1](/modules/102/assignment1021)

```tsx
// Import Statements:
import { contributorPolicyID } from 'gpte-config';
import { gql, useLazyQuery } from '@apollo/client';
import {
	Box,
	Heading,
	FormControl,
	FormLabel,
	Input,
	Button,
	Center,
	Spinner,
	Divider,
	Text,
	Link as CLink,
} from '@chakra-ui/react';
import { useFormik } from 'formik';
import * as React from 'react';
import { useState } from 'react';

// GraphQL Query Definition:
const TX_FROM_ADDRESS_WITH_POLICYID = gql`
	query TxFromAddressWithPolicyId(
		$address: String!
		$tokenPolicyId: Hash28Hex!
	) {
		transactions(
			where: {
				_and: [
					{ inputs: { address: { _eq: $address } } }
					{
						outputs: {
							tokens: { asset: { policyId: { _eq: $tokenPolicyId } } }
						}
					}
				]
			}
		) {
			hash
		}
	}
`;

// The <QueryComponent2 /> that can be imported to /ppbl-2023-front-end-starter/src/pages/index.tsx
export const QueryComponent2 = () => {
	// useState hook to store address from user input
	const [queryAddress, setQueryAddress] = useState<string | undefined>(
		undefined
	);

	// useFormik hook from formik library
	// Makes it easier to handle forms in React
	const formik = useFormik({
		initialValues: {
			cardanoAddress: '',
		},
		onSubmit: (values) => {
			setQueryAddress(values.cardanoAddress);
		},
	});

	// useLazyQuery hook from @apollo/client library
	// Handles fetching of GraphQL data
	// The name getUTxO can be anything we choose. This is a good name because it descibes what we are doing.
	const [getTx, { loading, error, data }] = useLazyQuery(
		TX_FROM_ADDRESS_WITH_POLICYID
	);

	// When a button is clicked, set the queryAddress and run the getUTxO query defined above
	const handleClick = () => {
		setQueryAddress(formik.values.cardanoAddress);
		getTx({
			variables: {
				address: formik.values.cardanoAddress,
				tokenPolicyId: contributorPolicyID,
			},
		});
	};

	// Boilerplate to handle useLazyQuery loading state.
	if (loading)
		return (
			<Center flexDirection='column'>
				<Heading>Loading</Heading>
				<Spinner />
			</Center>
		);

	// Boilerplate to handle useLazyQuery error state.
	if (error)
		return (
			<Center>
				<Heading>Error</Heading>
				<pre>{JSON.stringify(error)}</pre>
			</Center>
		);

	// If the query is not loading or in error state, this will be rendered on the page:
	return (
		<Box bg='theme.light' color='theme.dark' p='3' mt='5'>
			<Heading size='md' py='3'>
				Check Transaction from Address with Policy ID
			</Heading>
			<Text py='3'>
				This form returns the hash of any transaction from the provided address
				that included a PPBL 2023 Contributor Token in an output.
			</Text>
			<FormControl bg='theme.dark' color='theme.light' p='5'>
				<FormLabel>Enter a Cardano Preprod Address:</FormLabel>
				<Input
					mb='3'
					id='cardanoAddress'
					name='cardanoAddress'
					onChange={formik.handleChange}
					value={formik.values.cardanoAddress}
					placeholder='Preprod Address'
				/>
				<Button onClick={handleClick} size='sm'>
					Check Address
				</Button>
			</FormControl>

			{data && (
				<>
					<Divider pt='5' />
					<Heading size='md'>Query Result</Heading>
					<Box fontSize='sm' fontWeight='bold' p='2' color='theme.light'>
						Address: {queryAddress}
					</Box>
					{queryAddress &&
						data &&
						(data.transactions.length > 0 ? (
							<Box bg='green.400' color='theme.dark' mt='5' p='3' fontSize='sm'>
								<Text>
									This address sent a transaction with a PPBL2023 Token as
									output.
								</Text>
								<Text>
									TxHash:{' '}
									<CLink
										href={`https://preprod.cardanoscan.io/transaction/${data.transactions[0].hash}`}
										target='_blank'>
										{data.transactions[0].hash}
									</CLink>
								</Text>
							</Box>
						) : (
							<Box
								bg='yellow.400'
								color='theme.dark'
								mt='5'
								p='3'
								fontSize='sm'>
								There is no valid transaction from this address.
							</Box>
						))}
				</>
			)}
		</Box>
	);
};
```

<br />
---

## Koios Query: Get all UTxOs at Any Address

[Koios](https://www.koios.rest/) is an example of a customized query service on Cardano. Other examples are [Blockfrost](https://blockfrost.io/) and [Maestro](https://www.gomaestro.org/).

```tsx
// Import Statements:
import {
	Box,
	Heading,
	FormControl,
	FormLabel,
	Input,
	Button,
	Text,
} from '@chakra-ui/react';
import { useFormik } from 'formik';
import * as React from 'react';
import { useEffect, useState } from 'react';
import { KoiosProvider, UTxO } from '@meshsdk/core';

// The <KoiosComponentExample /> that can be imported to /ppbl-2023-front-end-starter/src/pages/index.tsx
export const KoiosComponentExample = () => {
	// useState hook to store address from user input
	const [queryAddress, setQueryAddress] = useState<string | undefined>(
		undefined
	);
	const koiosProvider = new KoiosProvider('preprod');
	const [koiosResultUTxOs, setKoiosResultUTxOs] = useState<UTxO[] | undefined>(
		undefined
	);

	// useFormik hook from formik library
	// Makes it easier to handle forms in React
	const formik = useFormik({
		initialValues: {
			cardanoAddress: '',
		},
		onSubmit: (values) => {
			setQueryAddress(values.cardanoAddress);
		},
	});

	// When a button is clicked, set the queryAddress
	const handleClick = () => {
		setQueryAddress(formik.values.cardanoAddress);
	};

	// When queryAddress is set, use koiosProvider.fetchAddressUTxOs to get get UTxOs at address
	useEffect(() => {
		const fetchAddressUTxOs = async () => {
			if (queryAddress) {
				const result = await koiosProvider.fetchAddressUTxOs(queryAddress);
				setKoiosResultUTxOs(result);
			}
		};
		if (queryAddress) {
			fetchAddressUTxOs();
		}
	}, [queryAddress]);

	// Rendered on the page:
	return (
		<Box bg='theme.light' color='theme.dark' p='3' mt='5'>
			<Heading size='md' py='3'>
				Example with KoiosProvider
			</Heading>
			<Text py='3'>
				This form returns a list of UTxOs for any Preprod Address.
			</Text>
			<FormControl bg='theme.dark' color='theme.light' p='5'>
				<FormLabel>Enter a Cardano Preprod Address:</FormLabel>
				<Input
					mb='3'
					id='cardanoAddress'
					name='cardanoAddress'
					onChange={formik.handleChange}
					value={formik.values.cardanoAddress}
					placeholder='Preprod Address'
				/>
				<Button onClick={handleClick} size='sm'>
					Check Address
				</Button>
			</FormControl>

			{koiosResultUTxOs && (
				<Box fontSize='xs'>
					<pre>{JSON.stringify(koiosResultUTxOs, null, 2)}</pre>
				</Box>
			)}
		</Box>
	);
};
```

import MDXLessonLayout from "@/src/components/lms/Lesson/MDXLessonLayout.tsx";
export default ({ children }) => <MDXLessonLayout>{children}</MDXLessonLayout>;
